procedure tostr_delphi(var s:string);
begin
  replace(s, '''', '''''');
end;

var
  TP_PControl:integer;

function _toCode(data:PScData; toType:byte):PScData;
begin
   Result := data;
   case toType of
     data_int:
      case data.getSubType of
       data_str:
        begin
          Result := MakeData('str2int(', true);
          Result.AddValue(data, true);
          Result.AddValue(MakeData(')', true), true);
        end;
       data_real:
        begin
          Result := MakeData('round(', true);
          Result.AddValue(data, true);
          Result.AddValue(MakeData(')', true), true);
        end;
      end;
     data_str:
      case data.getSubType of
       data_int:
        begin
          Result := MakeData('int2str(', true);
          Result.AddValue(data, true);
          Result.AddValue(MakeData(')', true), true);
        end;
       data_real:
        begin
          Result := MakeData('str2double(', true);
          Result.AddValue(data, true);
          Result.AddValue(MakeData(')', true), true);
        end;
      end;
     data_real:
      case data.getSubType of
       data_str:
        begin
          Result := MakeData('double2str(', true);
          Result.AddValue(data, true);
          Result.AddValue(MakeData(')', true), true);
        end;
      end
   end;
end;

type
  lng_indexer = (
      lng_begin,
      lng_end,
      lng_blk_priv_var,
      lng_blk_loc_var,
      lng_last);

function lng_proc(parser:TParser; obj:pointer; index:integer; args:TArgs):TScData;
var dt:PScData;
    old:string;
begin
  Result.SetValue('');
  case lng_indexer(index) of
   lng_begin:
    begin
      parser.codeb.level := parser.codeb.level + 1;
      parser.Print('begin');
      parser.PrintLine;
    end;
   lng_end:
    begin
      parser.Print('end;');
      parser.PrintLine;
      parser.codeb.level := parser.codeb.level - 1;
    end;
   lng_blk_priv_var:
    begin
      dt := GVarList.find('blk_priv_var');
      if dt = nil then
        parser.debug('BLK_PRIV_VAR - not found')
      else
       begin
         old := parser.codeb.select(dt.toStr());
         parser.Print(args.Values[0].toStr);
         parser.Print(':' + args.Values[1].toStr + ';');
         parser.PrintLine;
         parser.codeb.select(old);
       end;
    end;
   lng_blk_loc_var:
    begin
      dt := GVarList.find('loc_vars');
      if dt = nil then
        parser.debug('LOC_VARS - not found')
      else
       begin
         old := parser.codeb.select(dt.toStr());
         parser.Print(args.Values[0].toStr);
         parser.Print(':' + args.Values[1].toStr + ';');
         parser.PrintLine;
         parser.codeb.select(old);
       end;
    end;

  end;
end;

procedure fill_lng_object(var methods:TAObjMethod; var count:integer);
begin
  RegisterUserType('PControl');

  count := integer(lng_last);
  setlength(methods, count);
  methods[integer(lng_begin)] := MakeMethod('begin',     0, '');
  methods[integer(lng_end)] := MakeMethod('end',     0, '');
  methods[integer(lng_blk_priv_var)] := MakeMethod('decl_priv_var',     2, 'name, type');
  methods[integer(lng_blk_loc_var)] := MakeMethod('decl_loc_var',     2, 'name, type');
end;

const
  lng_count = 1;
  lngs:array[0..lng_count-1] of TLangRec = (
     (entry:'EntryPoint';     name:'delphi';  str_del: ''''; op_del: ' + ';   var_mask:'%n%i'; tostr_proc:tostr_delphi)
  );
