library make_exe;

uses
  Windows,
  kol,
  CGTShare in '..\..\CGTShare.pas';

type
  TCGrec = record
    Code:PStrList;
  end;
  PCGrec = ^TCGrec;

function buildGetParamsProc(var params:TBuildParams):integer; cdecl;
begin
  params.flags := CGMP_COMPRESSED or CGMP_RUN;
  Result := CG_SUCCESS;
end;

function buildMakePrj(const params:TBuildMakePrjRec):integer; cdecl;
begin
   PStrList(params.result).SaveToFile(params.prjFilename);
   PStrList(params.result).free;
   Result := CG_SUCCESS;
end;

function buildCompliteProc(const params:TBuildCompliteRec):integer; cdecl;
var src:string;
begin
  src := ExtractFilePath(params.prjFilename) + ExtractFileNameWOext(params.prjFilename) + '.exe';
  MoveFile(PChar(src), PChar(params.appFilename));
  Result := CG_SUCCESS;
end;

function buildRunProc(var params:TBuildRunRec):integer; cdecl;
var AppName:string;
    si:TStartupInfo;
    p: TProcessInformation;
    res:cardinal;
begin
   AppName := ExtractFilePath(params.FileName) + ExtractFileNameWOext(params.FileName) + '.exe';

   FillChar( Si, SizeOf( Si ) , 0 );
   with Si do
    begin
      cb := SizeOf( Si);
      dwFlags := STARTF_USESHOWWINDOW;
      wShowWindow := 4;
    end;
   SetCurrentDirectory(PChar(ExtractFilePath(AppName)));
   CreateProcess(nil,PChar('"' + AppName + '"'), nil, nil,false,CREATE_DEFAULT_ERROR_MODE, nil, nil, si, p);
   res := WAIT_TIMEOUT;
   Params.data := pointer(p.hProcess);
   while (res = WAIT_TIMEOUT) do
     res := WaitForSingleObject(p.hProcess,10);
   SetCurrentDirectory(PChar( GetStartDir ));

   Result := CG_SUCCESS;
end;

function buildStopProc(var params:TBuildRunRec):integer; cdecl;
begin
   TerminateProcess(cardinal(Params.data),0);
   Result := CG_SUCCESS;
end;

exports
    buildGetParamsProc,
    buildMakePrj,
    buildCompliteProc,
    buildRunProc,
    buildStopProc;

begin
end.
 